#/*++
#  Copyright (c) 2008, Intel Corporation
#  All rights reserved. 
# 
#  This UEFI SCT ("Software") is furnished under license and may only be used or copied
#  in accordance with the terms of that license UEFI Contributor Agreement.
#  No license, express or implied, by estoppel or otherwise, to any intellectual property
#  rights is granted by this document. The Software is subject to change without notice,
#  and should not be construed as a commitment by Intel Corporation to market, license,
#  sell or support any product or technology. Unless otherwise provided for in the license
#  under which this Software is provided, the Software is provided AS IS, with no warranties
#  of any kind, express or implied. Except as expressly permitted by the Software license,
#  neither Intel Corporation nor its suppliers assumes any responsibility or liability
#  for any errors or inaccuracies that may appear herein.
#--*/
################################################################################
CaseLevel         CONFORMANCE
CaseAttribute     AUTO
CaseVerboseLevel  DEFAULT
set reportfile    report.csv

#
# test case Name, category, description, GUID...
#
CaseGuid        3969E3B3-C834-4a52-813A-FED3B913248B
CaseName        DestroyChild.Conf1.Case1
CaseCategory    MNP
CaseDescription {Test the DestroyChild conformance of MNPSB - Call             \
	               MnpServiceBinding.DestroyChild() when the parameter           \
	               ChildHandle being NULL. The return status should be           \
	               EFI_INVALID_PARAMETER.}
################################################################################

Include MNP/include/Mnp.inc.tcl

#
# Begin log ...
#
BeginLog
BeginScope _MNP_DESTROYCHILD_CONFORMANCE1_CASE1_

#
# Parameter Definition
# R_ represents "Remote EFI Side Parameter"
# L_ represents "Local OS Side Parameter"
#
UINTN                            R_Status

#
# Destroy un-existed child
#
MnpServiceBinding->DestroyChild "0, &@R_Status"
GetAck
set assert [VerifyReturnStatus R_Status $EFI_INVALID_PARAMETER]
RecordAssertion $assert $MnpDestroyChildConf1AssertionGuid001                  \
                "MnpSB.CreateChild - Destroy NULL Child "                      \
                "ReturnStatus - $R_Status,ExpectedStatus - $EFI_INVALID_PARAMETER"
                
                
EndScope _MNP_DESTROYCHILD_CONFORMANCE1_CASE1_

#
# End log ...
#
EndLog
