#/*++
#  Copyright (c) 2008, Intel Corporation
#  All rights reserved. 
# 
#  This UEFI SCT ("Software") is furnished under license and may only be used or copied
#  in accordance with the terms of that license UEFI Contributor Agreement.
#  No license, express or implied, by estoppel or otherwise, to any intellectual property
#  rights is granted by this document. The Software is subject to change without notice,
#  and should not be construed as a commitment by Intel Corporation to market, license,
#  sell or support any product or technology. Unless otherwise provided for in the license
#  under which this Software is provided, the Software is provided AS IS, with no warranties
#  of any kind, express or implied. Except as expressly permitted by the Software license,
#  neither Intel Corporation nor its suppliers assumes any responsibility or liability
#  for any errors or inaccuracies that may appear herein.
#--*/
if {[info exist TCP4_PROC_TCL] == 1} {
  return
}
set TCP4_PROC_TCL 1

proc AddEntryInArpCache { } {
  global ENTS_CUR_CHILD DEF_EUT_IP_ADDR DEF_ENTS_IP_ADDR DEF_ENTS_MAC_ADDR
	BeginScope _PROC_ADD_ENTRY_IN_ARP_CACHE_
  
  EFI_IP_ADDRESS                   R_Proc_StationAddress
  EFI_ARP_CONFIG_DATA              R_Proc_ArpConfigData
  EFI_IP_ADDRESS                   R_Proc_TargetSwAddress
  EFI_MAC_ADDRESS                  R_Proc_TargetHwAddress
  UINTN                            R_Proc_ArpStatus
  UINTN                            R_Proc_ArpHandle
  
  ArpServiceBinding->CreateChild "&@R_Proc_ArpHandle, &@R_Proc_ArpStatus"
  GetAck
  SetVar     [subst $ENTS_CUR_CHILD]  @R_Proc_ArpHandle
  
  SetIpv4Address R_Proc_StationAddress.v4     $DEF_EUT_IP_ADDR
  SetVar R_Proc_ArpConfigData.SwAddressType   0x800
  SetVar R_Proc_ArpConfigData.SwAddressLength 4
  SetVar R_Proc_ArpConfigData.StationAddress  &@R_Proc_StationAddress
  SetVar R_Proc_ArpConfigData.EntryTimeOut    0
  SetVar R_Proc_ArpConfigData.RetryCount      0
  SetVar R_Proc_ArpConfigData.RetryTimeOut    0
  
  Arp->Configure {&@R_Proc_ArpConfigData, &@R_Proc_ArpStatus}
  GetAck
  
  SetIpv4Address   R_Proc_TargetSwAddress.v4 $DEF_ENTS_IP_ADDR
  SetEthMacAddress R_Proc_TargetHwAddress $DEF_ENTS_MAC_ADDR
  
  #
  # check point
  #
  Arp->Add {FALSE, &@R_Proc_TargetSwAddress, &@R_Proc_TargetHwAddress, 0, TRUE, &@R_Proc_ArpStatus}
  GetAck
}


# Procedure Name
#   DelEntryInArpCache
# Procedure Description:
#   Call ARP.Delete() to delete an entry in ARP cache.
# Arguments:
#   EutStationAddress  - EUT station IP address.
#   EntsSwAddress      - ENTS IP address.
#   EntsHwAddress      - ENTS MAC address.
# Returns:
#   Nothing.
#
proc DelEntryInArpCache { } {
  global ENTS_CUR_CHILD DEF_EUT_IP_ADDR DEF_ENTS_IP_ADDR DEF_ENTS_MAC_ADDR
  UINTN TempCurChild
  
  SetVar TempCurChild @[subst $ENTS_CUR_CHILD]
  SetVar [subst $ENTS_CUR_CHILD]  @R_Proc_ArpHandle
  
  Arp->Delete {TRUE, &@R_Proc_TargetSwAddress, &@R_Proc_ArpStatus}
  GetAck

  ArpServiceBinding->DestroyChild {@R_Proc_ArpHandle, &@R_Proc_ArpStatus}
  GetAck

  SetVar [subst $ENTS_CUR_CHILD]  @TempCurChild
  
  EndScope _PROC_ADD_ENTRY_IN_ARP_CACHE_
}