/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:
  
    EmsEftpStrategy.h
    
Abstract:

    Incude header files EMS Eftp

--*/

#ifndef __EMS_EFTP_STRATEGY_H__
#define __EMS_EFTP_STRATEGY_H__

typedef struct Eftp_Strategy_Struct {
  INT8                          FileName[MAX_FILENAME_LEN];
  FILE                          *Fp;
  INT32                         FileSizeInBytes;
  INT32                         FileMaxBlkNo;
  INT32                         BlockSizeInBytes;
  INT32                         NextBlkNo;
  INT32                         LastAckNo;

  VOID_P (*HandlePkt) (struct Eftp_Strategy_Struct *, CONST INT8 *, INT32 );
  INT32 (*Open) (struct Eftp_Strategy_Struct *, CONST INT8 *);
  VOID_P (*Close) (struct Eftp_Strategy_Struct *);
}Eftp_Strategy;

#define StrategyToSession(Strategy)  ((Eftp_Session *)((UINT8 *)(Strategy) - (UINT32)&(((Eftp_Session *)0)->Strategy)))

#endif
