/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:
  
    EmsTclCleanup.h
    
Abstract:

    Incude header files for EMS TCL cleanup functions

--*/

#ifndef	__EMSTCLCLEANUP__
#define	__EMSTCLCLEANUP__

#include <tcl.h>
#include <EmsTypes.h>

typedef struct EmsTclResMngStruct {
  struct EmsTclResMngStruct *Next;
  VOID * (*CleanupFunc) (VOID *);
  VOID * Res;
}EmsTclResMng;

VOID
EmsTclResStackPush (
  EmsTclResMng *Mng
  )
/*++

Routine Description:

  Push a EMS TCL resource into stack

Arguments:

  Mng - The structure for the EMS TCL resource management

Returns:

  None

--*/
;

VOID
EmsTclResStackPop (
  EmsTclResMng **Mng
  )
/*++

Routine Description:

  Pop a EMS TCL resource from stack

Arguments:

  Mng - The structure for the EMS TCL resource management

Returns:

  None

--*/
;

VOID_P
ResTclInit (
  IN Tcl_Interp *Interp
  )
/*++

Routine Description:

  EMS cleanup related TCL initialization.

Arguments:

  Interp      - TCL intepreter.

Returns:

  None

--*/
;

STATIC Tcl_CmdProc EmsTclResCleanup;

#endif
