/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Copyright (c) 2006, Intel Corporation
All rights reserved. 

This UEFI SCT ("Software") is furnished under license and may only be used or copied
in accordance with the terms of that license UEFI Contributor Agreement.
No license, express or implied, by estoppel or otherwise, to any intellectual property
rights is granted by this document. The Software is subject to change without notice,
and should not be construed as a commitment by Intel Corporation to market, license,
sell or support any product or technology. Unless otherwise provided for in the license
under which this Software is provided, the Software is provided AS IS, with no warranties
of any kind, express or implied. Except as expressly permitted by the Software license,
neither Intel Corporation nor its suppliers assumes any responsibility or liability
for any errors or inaccuracies that may appear herein.

Module Name:

  NetInterfaceConfig.h

Abstract:

--*/

#ifndef __PROTOCOL_NET_INTERFACE_CONFIG_H__
#define __PROTOCOL_NET_INTERFACE_CONFIG_H__

#include "IP4.h"

#define EFI_NET_INTERFACE_CONFIG_PROTOCOL_GUID \
  { 0xdc5800a1, 0xba61, 0x470b, 0xb4, 0x0e, 0x6e, 0x24, 0x34, 0xd6, 0x71, 0x2b }


EFI_FORWARD_DECLARATION (EFI_NET_INTERFACE_CONFIG_PROTOCOL);

#define NET_MAX_PROTOCOL_ADDRESS_LENGTH sizeof(EFI_IP_ADDRESS)
#define NET_MAX_HARDWARE_ADDRESS_LENGTH sizeof(EFI_MAC_ADDRESS)

typedef struct _NET_PROTOCOL_ADDRESS
{
  UINT16        ProtocolAddressType;
  UINT8         ProtocolAddressLen;
  UINT8         ProtocolAddress[ NET_MAX_PROTOCOL_ADDRESS_LENGTH ];
} NET_PROTOCOL_ADDRESS;

typedef struct _NET_HARDWARE_ADDRESS
{
  UINT16        HardwareAddressType;
  UINT8         HardwareAddressLen;
  UINT8         HardwareAddress[ NET_MAX_HARDWARE_ADDRESS_LENGTH ];
} NET_HARDWARE_ADDRESS;

typedef enum _IP4_CONFIG_SOURCE
{
  IP4_CONFIG_SOURCE_DHCP,
  IP4_CONFIG_SOURCE_STATIC,
  IP4_CONFIG_SOURCE_MAX
} IP4_CONFIG_SOURCE;

//#pragma pack(1)

/*
typedef struct _IP4_CONFIG_INFO
{
  NET_HARDWARE_ADDRESS      HardwareAddress;
  IP4_CONFIG_SOURCE         Source;
  UINT32                    ConfigDataLength;
  UINT8                     ConfigData[ 1 ];
} IP4_CONFIG_INFO;
*/

typedef struct _IP4_CONFIG_INFO
{
  NET_HARDWARE_ADDRESS      HardwareAddress;
  IP4_CONFIG_SOURCE         Source;
  UINT32                    ConfigDataLength;
  EFI_IP4_IPCONFIG_DATA     ConfigData[ 1 ];
} IP4_CONFIG_INFO;




#define MAX_NETWORK_INTERFACE_NAME_LENGTH       64

#define EFI_NET_MAX_IP4_CONFIG_IN_VARIABLE    16

typedef struct _IP4_CONFIG_VARIABLE
{
  UINT32                    Count;            // No more than EFI_NET_MAX_IP4_CONFIG_IN_VARIABLE
  IP4_CONFIG_INFO           ConfigInfo[ 1 ];
} IP4_CONFIG_VARIABLE;

//#pragma pack()


typedef
EFI_STATUS
(EFIAPI *EFI_NET_INTERFACE_CONFIG_GET_INFO) (
  IN  EFI_NET_INTERFACE_CONFIG_PROTOCOL *This,
  IN OUT UINT32                         *ConfigInfoSize,
  OUT IP4_CONFIG_INFO                   *ConfigInfoBuffer    OPTIONAL );

typedef
EFI_STATUS
(EFIAPI *EFI_NET_INTERFACE_CONFIG_SET_INFO) (
  IN  EFI_NET_INTERFACE_CONFIG_PROTOCOL *This,
  IN  UINT32                            ConfigInfoSize,
  IN  IP4_CONFIG_INFO                   *ConfigInfoBuffer    OPTIONAL,
  IN  BOOLEAN                           NeedReConfig );

typedef
EFI_STATUS
(EFIAPI *EFI_NET_INTERFACE_CONFIG_GET_NAME) (
  IN  EFI_NET_INTERFACE_CONFIG_PROTOCOL *This,
  IN  UINT32                            *NameBufferLen,
  IN  UINT16                            *NameBuffer          OPTIONAL,
  IN  NET_HARDWARE_ADDRESS              *HardwareAddress     OPTIONAL );


typedef struct _EFI_NET_INTERFACE_CONFIG_PROTOCOL {
  EFI_NET_INTERFACE_CONFIG_GET_INFO   GetInfo;
  EFI_NET_INTERFACE_CONFIG_SET_INFO   SetInfo;
  EFI_NET_INTERFACE_CONFIG_GET_NAME   GetName;
} EFI_NET_INTERFACE_CONFIG_PROTOCOL;


extern EFI_GUID gEfiNetInterfaceConfigProtocolGuid;

#endif
