/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  TestDriver.h

Abstract:

  for Protocol Handler Boot Services Black Box Test

--*/

#ifndef TEST_DRIVER_H
#define TEST_DRIVER_H

#include "Efi.h"
#include "EfiTestLib.h"
#include "ProtocolDefinition.h"

#define MAX_STRING_LEN      250

#include EFI_PROTOCOL_DEFINITION (DevicePath)
#include EFI_PROTOCOL_DEFINITION (DriverBinding)
#include EFI_PROTOCOL_DEFINITION (LoadedImage)
#include EFI_PROTOCOL_DEFINITION (PlatformDriverOverride)
#include EFI_PROTOCOL_DEFINITION (BusSpecificDriverOverride)

#include EFI_TEST_PROTOCOL_DEFINITION (TestProfileLibrary)

typedef struct {
  EFI_HANDLE                  Handle;
  EXTERNAL_DRIVER_PROTOCOL_1  ExProt1;
  EFI_STATUS                  *StatusArray;
  EFI_HANDLE                  *HandleArray;
  EFI_GUID                    *ProtGuidArray;
  UINTN                       ArrayCount;
  UINTN                       Count;
  EFI_HANDLE                  ChildHandle;
} TEST_DRIVER_PRIVATE_DATA;

typedef struct {
  EFI_HANDLE                  Handle;
  EXTERNAL_DRIVER_PROTOCOL_1  ExProt1;
  EFI_DRIVER_BINDING_PROTOCOL DriverBinding;
  EFI_STATUS                  *StatusArray;
  EFI_HANDLE                  *HandleArray;
  EFI_GUID                    *ProtGuidArray;
  UINTN                       ArrayCount;
  UINTN                       Count;
  EFI_HANDLE                  ChildHandle;
} DBINDING_DRIVER_PRIVATE_DATA;

#endif