/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  Sct.h

Abstract:

  SCT master include file.

--*/

#ifndef _EFI_SCT_H_
#define _EFI_SCT_H_

//
// Includes
//

#include "Efi.h"
#include "EfiShellLib.h"
#include "EfiTest.h"
#include "EfiTestLib.h"
#include "LibPrivate.h"
#include EFI_TEST_PROTOCOL_DEFINITION (BbTest)
#include EFI_TEST_PROTOCOL_DEFINITION (WbTest)
#include EFI_TEST_PROTOCOL_DEFINITION (StandardTestLibrary)
#include EFI_TEST_PROTOCOL_DEFINITION (TestProfileLibrary)
#include EFI_TEST_PROTOCOL_DEFINITION (TestRecoveryLibrary)
#include EFI_TEST_PROTOCOL_DEFINITION (TestLoggingLibrary)
#include EFI_TEST_PROTOCOL_DEFINITION (TestOutputLibrary)
#include EFI_PROTOCOL_DEFINITION (DevicePath)
#include EFI_PROTOCOL_DEFINITION (SimpleNetwork)

#include "ApTest.h"

#include "SctTypes.h"
#include "SctCore.h"

#include "ExecuteSupport.h"

#include "SctData.h"
#include "SctDataEx.h"
#include "SctDebug.h"
#include "SctExecute.h"
#include "SctLoad.h"
#include "SctMisc.h"
#include "SctOperation.h"
#include "SctOutput.h"
#include "SctReport.h"
#include "SctDeviceConfig.h"
#include "SctUi.h"

#include "SctDef.h"


#include "Eas.h"

#endif
